/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "LCD_Driver.h"

void InitADC7(void)
{
    /*  1. GPIO ʼ */ 
    GPIOA->OFFD |= 0x00800000;      // ֹ GPIOA.7 ͨ
    SYS->GPAMFP.ADC7_SS21_AD6 = 1;  // ѡ GPIOA.7 Pin ܿΪ  ADC7

    /*  2. ʹܲѡADC ʱԴ, ȻʹADCģ*/          
    SYSCLK->CLKSEL1.ADC_S = 3;      // ѡ ADC ʱԴ = HIRC
    SYSCLK->CLKDIV.ADC_N  = 1;      // ADC ʱ = HIRC/(ADC_N+1) = 22MHz/2 = 11MHz
    SYSCLK->APBCLK.ADC_EN = 1;      // ʹ ADC ʱ
    ADC->ADCR.ADEN = 1;             // ʹ ADC ģ

    /*  3. ѡ ADC ͨ ģʽ */
    ADC->ADCR.DIFFEN = 0;           // ģʽģʽ
    ADC->ADCR.ADMD   = 0;           // תģʽ
    ADC->ADCHER.CHEN = 0x80;        // ʹ ģͨ7
                                    // ѡ ADC7  = ⲿģ

    ADC->ADSR.ADF = 1;              //  A/D ת־
    ADC->ADCR.ADST = 1;             // ʼA/Dת
}

void InitPWM0(void)
{
    /*  1. GPIO ʼ */
    SYS->GPAMFP.PWM0_AD13 = 1;      // ѡ GPIOA.12 Pin ܿΪPWM0

    /*  2. ʹܲѡ PWM ʱԴ*/
    SYSCLK->APBCLK.PWM01_EN = 1;    // ʹ PWM01 ʱ
    SYSCLK->CLKSEL1.PWM01_S = 0;    // ѡ PWM01ʱԴ = ⲿʱ (12 MHz)

    PWMA->PPR.CP01 = 5;             //  PWM01 ԤƵֵ 5
    PWMA->CSR.CSR0 = 4;             //  PWM0 ʱԴƵֵ = 1
                                    // PWM ʱ = ʱԴ/(ԤƵֵ+1)/Ƶֵ
                                    //          = 12MHz/(5+1)/1 = 2MHz

    /*  3. ѡ PWM0 ģʽ  PWM Ƶ */
    PWMA->PCR.CH0MOD = 1;           // PWM0 Զװģʽ (0:ģʽ, 1:Զװģʽ)

                                    // CH0MOD0д1CNR  CMR ֵᱻԶ
    PWMA->CNR0 = 40000-1;           // PWM0 ռձ= (CMR+1)/(CNR+1) = 2000/40000 = 1/20
    PWMA->CMR0 = 3000-1;            // PWM Ƶ = PWM ʱ/(CNR+1) = 2MHz/40000 = 50Hz
                                    // PWM  = 1/50 = 20 ms

    PWMA->PCR.CH0INV = 0;           // ֹ PWM   (0:, 1:)
    PWMA->PCR.CH0EN = 1;            // ʹ PWM ʱ0 ʼ
    PWMA->POE.PWM0 = 1;             // ʹ PWM0   (GPIOA.12 Pin)
}

void Delay(int count)
{
    while(count--);
}

/*----------------------------------------------------------------------------
  MAIN 
  ----------------------------------------------------------------------------*/
int32_t main (void)
{
    uint32_t u32Temp, u32Deg;
    char adc_value[15] = "              ";

    UNLOCKREG();
    SYSCLK->PWRCON.XTL12M_EN = 1;   // ʹⲿʱ (12MHz)
    SYSCLK->CLKSEL0.HCLK_S = 0;     // HCLK = ⲿʱƵ
    LOCKREG();

    InitPWM0();                     // ʼ PWM0
    InitADC7();                     // ʼ ADC7

    Initial_pannel();               // óʼLCD幦ܺ 
    clr_all_pannal();               // LCD

    /* LCDʾϢ */
    print_lcd(0, "Servo Motor");
    print_lcd(1, "PWM Period:20ms");
    print_lcd(2, "PWM High Width:");

    while(1)
    {
        while(ADC->ADSR.ADF == 0);  // ȴ A/D ת
        ADC->ADSR.ADF = 1;          //  A/D ת־

        // ȡ A/D תӦ
        u32Temp = 2000 + (ADC->ADDR[7].RSLT * (2001) / 4096);

        // CMRֵԵPWMռձ
        PWMA->CMR0 = u32Temp - 1;
        
        if (u32Temp >= 3000)
        {
            u32Deg = u32Temp - 3000;
            sprintf(adc_value,"%d.%03dms,+%02d.%ddeg",(u32Temp/2)/1000, (u32Temp/2)%1000, (u32Deg*45)/1000, ((u32Deg*45)%1000)/100);
        }
        else
        {
            u32Deg = 3000 - u32Temp;
            sprintf(adc_value,"%d.%03dms,-%02d.%ddeg",(u32Temp/2)/1000, (u32Temp/2)%1000, (u32Deg*45)/1000, ((u32Deg*45)%1000)/100);
        }

        print_lcd(3, adc_value);    // ʾ PWMȺת
                                    // PWM Ϊ 1.0ms  2.0ms, תǴ -45   45 
        Delay(20000);
        ADC->ADCR.ADST = 1;         // ٴοʼ A/D ת 
    }
}

